#!/usr/bin/env python

import pygtk
pygtk.require('2.0')
import gtk
import hildon
import os

class HelloWorld(hildon.Program):

	def button_clicked(self, widget, data=None):
		if data == "start":
			if self.file != None:
				child_pid = os.fork()
				if child_pid == 0:
					pass
				else:
					args = []
					args.append(self.file[(self.file.rfind("/")+1):]) #apperently first arg is title window ?!
					args.append("-frameskip")
					args.append(str(self.buttonFrameskip.get_active()))
					args.append("-cyclemult")
					args.append(str(self.buttonCycleMult.get_active()+1))
					if self.buttonSound.get_active():
						args.append("-nosound")
					args.append(str(self.file))
					print "start"
					os.execv("/home/opt/psx4m/psx4m", args)
		elif data == "choosefile":
			print "choose file"
			chooser = hildon.FileChooserDialog(self.window, gtk.FILE_CHOOSER_ACTION_OPEN,hildon.FileSystemModel())
			filter = gtk.FileFilter()
			filter.set_name("roms")
			filter.add_pattern("*.bin")
			filter.add_pattern("*.iso")
			filter.add_pattern("*.img")   
			chooser.add_filter(filter)
			chooser.set_current_folder("/home/user/MyDocs/")
			response = chooser.run()
			print chooser.get_filename()
			self.file = chooser.get_filename()
			self.buttonChooseRom.set_label(self.file[(self.file.rfind("/")+1):])
			chooser.destroy()

	def delete_event(self, widget, event, data=None):
		#return false and main window destroyed
		return False

	def destroy(self, widget, data=None):
		gtk.main_quit()

	def __init__(self):
		hildon.Program.__init__(self)
		
		self.window = hildon.Window()
		self.window.set_title("Psx4m")
		self.window.connect("delete_event", self.delete_event)
		self.window.connect("destroy", self.destroy)
		
		# vertical box
		self.vbox = gtk.VBox(False, 0)
		self.window.add(self.vbox)
		self.vbox.show()	

		# top banner
		self.banner = gtk.Image()
		self.banner.set_from_file("/home/opt/psx4m/psx4all_banner.jpg")
		self.banner.show()	
		self.vbox.pack_start(self.banner, False, False, 20)

		# first button row
		self.buttons1 = gtk.HBox(False, 0)
		self.vbox.pack_start(self.buttons1, False, False, 20)
		self.buttons1.show()

		self.buttonStart = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_THUMB_HEIGHT,hildon.BUTTON_ARRANGEMENT_VERTICAL)
		self.buttonStart.set_label("Start")
		self.buttonStart.connect("clicked", self.button_clicked, "start")
		self.buttonStart.show()		

		self.buttonChooseRom = hildon.Button(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_THUMB_HEIGHT, hildon.BUTTON_ARRANGEMENT_VERTICAL)
		self.buttonChooseRom.set_label("Select ROM...")
		self.buttonChooseRom.connect("clicked", self.button_clicked, "choosefile")
		self.buttonChooseRom.show()
		
		self.buttons1.pack_start(self.buttonChooseRom, True, True, 5)
		self.buttons1.pack_start(self.buttonStart, True, True, 5)
		
		# second button row
		self.buttons2 = gtk.HBox(False, 0)
		self.vbox.pack_start(self.buttons2, False, False, 5)
		self.buttons2.show()

		self.buttonSound = hildon.CheckButton(gtk.HILDON_SIZE_AUTO_WIDTH | gtk.HILDON_SIZE_FINGER_HEIGHT)
		self.buttonSound.set_label("Mute Sound")
		self.buttonSound.show()

		self.buttonFrameskip = hildon.PickerButton(gtk.HILDON_SIZE_AUTO_WIDTH |gtk.HILDON_SIZE_FINGER_HEIGHT,hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
		self.selectorFrameskip = hildon.TouchSelector()
		self.storeFrameskip = gtk.ListStore(str);
		for i in range(9):
			self.storeFrameskip.append(row=[str(i)])
		self.selectorFrameskip.append_text_column(self.storeFrameskip, True)
		self.buttonFrameskip.set_selector(self.selectorFrameskip)
		self.buttonFrameskip.set_title("Frameskip")
		self.buttonFrameskip.show()

		self.buttonCycleMult = hildon.PickerButton(gtk.HILDON_SIZE_AUTO_WIDTH |gtk.HILDON_SIZE_FINGER_HEIGHT,hildon.BUTTON_ARRANGEMENT_HORIZONTAL)
		self.selectorCycleMult = hildon.TouchSelector()
		self.storeCycleMult = gtk.ListStore(str);
		for i in range(1,11):
			self.storeCycleMult.append(row=[str(i)])
		self.selectorCycleMult.append_text_column(self.storeCycleMult, True)
		self.buttonCycleMult.set_selector(self.selectorCycleMult)
		self.buttonCycleMult.set_title("Cycle Multiplier")
		self.buttonCycleMult.show()

		self.buttons2.pack_start(self.buttonSound, True, True, 5)
		self.buttons2.pack_start(self.buttonFrameskip, True, True, 5)
		self.buttons2.pack_start(self.buttonCycleMult, True, True, 5)

		self.window.show()


	def main(self):
		gtk.main()




if __name__ == "__main__": 
	hello = HelloWorld()
	hello.main()
